var newtonImpulseRecord[8];
var Record[8];

var num_energy_spheres; // track the # of energy spheres fired by a ship
var recent_weapon_fire; // flag to indicate we just fired an energy sphere

// stuff to handle scrolling messages

var message_running;
var game_is_exiting;

var sleeping;

panel help_panel
{
	pos_x =175;
	pos_y =100;
	flags =refresh;
	digits (65,0,"Forward",sm_font,0,0);
	digits (90,10,"|",sm_font,0,0);
	digits (0,20,"      Decend -- Q W E -- Ascend",sm_font,0,0);
	digits (0,30,"Strafe Left -- A  S  D -- Strafe Right",sm_font,0,0);
	digits (90,40,"|",sm_font,0,0);	
	digits (85,50,"Aft",sm_font,0,0);
	
	digits (500,0," Nose Down",sm_font,0,0);
	digits (530,10,"|",sm_font,0,0);
	digits (450,20,"  Roll Left --  U I O -- Roll Right",sm_font,0,0);
	digits (450,30,"Nose Left -- J K L -- Nose Right",sm_font,0,0);
	digits (530,40,"|",sm_font,0,0);	
	digits (500,50,"  Nose Up",sm_font,0,0);	
}


panel timer_panel 
{
	pos_x =0;
	pos_y =0;
	flags =refresh;
	
	digits 100,30,3.2,med_font,1,elapsed_time;
	digits 300,30,4.0,med_font,1,pad_distance;
	
}

panel Distance_panel
{
	pos_x =0;
	pos_y =0;
	flags =refresh;
	

	digits 300,30,4.0,med_font,1,pad_distance;
	
}


string	msg_str1 = " Welcome to the ore processing ship Lunar-4 

Congratulations on being selected as a Tug Pilot Trainee.

You are required to pass the landing skills test before 
you will be promoted to rookie tug pilot. 

The Ore Hauler ships have their SHIELDS UP for protection
- WARNING - DO NOT MAKE CONTACT with their shields
- Captains Orders -
------------------------------------";


// second group of credits to be displayed
string	msg_str2 = "Remember slow and easy when you first start out!

The landing pads can not lock on your tug if 
your land with to much force. 

Land in the designated time within 30 quads of pad
Do not make contact with Ore Haulers on deck
------------------------------
Good luck.";

string	msg_str3 = " Well that was not pretty but at least you
got the job done!  Congratulations!

As a Tug Pilot one of your jobs will be to move the Ore Haulers to and
from the various decks and interior of Lunar 4. Practice makes perfect. 
So Practice up.. You need it.

I hope you enjoyed your training program.  
----------------------------------------";

string	msg_str4 = " Take some time off, you earned it! You might want to
get a few rookies together and try a few games of 'King of the Landing Pad' It's
a great skill building exercise, and loads of fun!!

If you have never played it before, check out the instructions document PadKing.txt.
------------------------------";


string	msg_str5 = " What is the matter rookie, 
did you forget how to fly a tug?

Maybe you need some basic training again!  
I am demoting you back to trainee. 
If you can pass the landing test again, 
I will give you another chance at moving an ore hauler  
------------------------------";

string	msg_str6 = " Here are some tips for getting the
ore hauler below deck:

Try turning the Ore Hauler sideways before attempting to take it below.
Don't RAM into an Ore hauler. You'll just bounce off it's force shield. 
One you have made GENTLE contact to it's shield, apply steady pressure to move it. 

BETTER LUCK NEXT TIME --- TRAINEE
----------------------------------";

string	msg_str7 = " Congratulations on completeing the Landing Test
Great work!! There is just one more test to go.

As you probably already know, The Larger Ore Hauler ships are not equipped
with thrusters and therefore cannot move about the decks of Lunar 4.

Your main job as a Tug Pilot will be to move these ships into the interior
hold of Lunar 4 so that the Ore can be unloaded and processed.  
----------------------------------";

string	msg_str8 = " Before you are promoted to Rookie Pilot,
you must pass one more test. 

You must move the indicated Ore Hauler below deck by any
means necessary. You have 5 minutes to complete this task. If you fail,
you will be given 1 chance to try again.
----------------------------------
Good Luck";

string	msg_str10 = " Welcome to the ore processing ship Lunar-4 

Congratulations on being selected as a Tug Pilot Trainee.

We're glad to see that you chose to do a few practice landings
before proceeding to the tests. You might want to just fly around
Lunar 4 for a bit to make sure you are familiar with the control keys
on your tug. Don't wander to far off. Sensors detect space turbulence.

The Ore Hauler ships have their SHIELDS UP for protection
- WARNING - DO NOT MAKE CONTACT with their shields !!!
- Captains Orders -
------------------------------------";

string	msg_str11 = "The control keys will be displayed for your reference.
Take a few minutes to familiarize yourself with the keys before attempting
landings. Keep in mind that you have 5 differnt axis (10 control keys) to deal with.

Remember slow and easy when you first start out! 
The landing pads can not lock onto your tug if 
your land with to much force. 
------------------------------
Good luck.";

// first group of credits to be displayed
string	msg_str20 = " Scripts and Design by Giorgi3

THANKS TO:
Doug for his Flight Simulator Workshop

Acknex User Magazine

Acknex Unlimited Contributors
------------------------------

Camera script - based on user contribution zelda.lockon

Lunar 4 Ship - by Christopher Davis (Fall 2005 contest entry)
- Mods by giorgi3

Tug Ship, Ore Haulers, & Captains Ship - From Locoweeds Spaceship Pack";



// second group of credits to be displayed
string	msg_str21 = "Created with 3D GameStudio
Copyright Conitec 2001

send comments to giorgi3@mchi.com"
;


TEXT msg_txt
{
	LAYER 350;
	FONT	digi_font;
	STRING = "";
}

TEXT msg_txt2
{
	LAYER 350;
	FONT	digi_font;
	STRING msg_str2;
}

//-----------------------------------------------------------------------------create_newton_entity
function create_newton_entity(material)
{	
	var collisionType;
	var body;
	dll_handle=newtonHandle;
	


	collisionType=1;

	
	body=NewtonSpawnEntity(my,collisionType);
	NewtonSetBodyMass(body,my._mass);


	//	NewtonSetBodyForceAndTorque(body,ApplyGravityForceEvent);
	NewtonSetBodyMaterial(body,material);
	NewtonSetBodyActiveState(body,1);

	my.ENABLE_TRIGGER=ON;
	my.ENABLE_CLICK=ON;
	my.ENABLE_PUSH=ON;
	my.ENABLE_SHOOT=ON;
	//	my.EVENT=NewtonGSScriptEvent;
	//

}




function ballphysics()
{
	var body;
	dll_handle=newtonHandle;
	body=NewtonSpawnEntity(my,1); // spherical collision shape
	NewtonSetBodyMass(body,0.1);  // was 5
	NewtonSetBodyLinearDamp(body,0.0);
	NewtonSetBodyAngularDamp(body,0.05,0.05,0.05);
	NewtonSetBodyAutoActiveState(body,1);
	NewtonSetBodyActiveState(body,1);
	NewtonSetBodyMaterial(body,ivory_material);
	NewtonSetBodyForceAndTorque(body,gravity_event);	
	NewtonAddDryFriction(body,0.1);
}

material MAT1
{
	emissive_red = 255;
	emissive_green = 1;
	emissive_blue = 1;
	ambient_red = 255;
	ambient_green = 135;
	ambient_blue = 1;
	diffuse_red = 255;
	diffuse_green = 135;
	diffuse_blue = 1;
	specular_red = 255;
	specular_green = 135;
	specular_blue = 1;
	power = 2.344;
	alpha = 100;
	albedo = 50.218;

}

function energize_sphere()
{
	my.HEALTH=0;
	while (my.HEALTH) < 100
	{
		sleep (1);
		my.HEALTH+=5;
		send_skill(my.HEALTH,0);
	}
	my.SPHERE_ENERGIZED=on;
}

action energy_sphere 

{
	
	my._collisionshape=0;  // box
	my._mass=1;    // was 10
	my._lineardrag=0.1;    //was 0.1
	my._angulardragx=0.1;
	my._angulardragy=0.1;
	my._angulardragz=-10;   // was 0.1
	my._autorest=0;
	my._startactive=1;
	my._material=ivory_material;
	my._shapefactor=0.8; // density
	p_phevent=ball_event;



	proc_late();
	var body;
	var power=6;
	var spin_timer;

	
	//	var angle;
	//	var cue[3];
	//	
	// From lightmxr
	my.red = 255;
	my.green = 135;
	my.blue = 1;
	my.lightrange = 500;
	my.alpha = 50;
	my.albedo = 50;
	my.material = MAT1;
	my.transparent = off;
	my.flare = on;
	my.overlay = off;
	my.Metal = off;
	my.Light = off;

	// define this entity as an energy sphere and save the ship number that created it
	my.ENTITY_TYPE = ENERGY_SPHERE_TYPE;
	my.SHIP_NUM = you.SHIP_NUM;

	body=enable_physics();
	//ballphysics();
	
	dll_handle=newtonHandle;
	body=NewtonGetBody(my);

	record[0]=my.x;    // direction toward where we are firing is where the energy sphere was created 
	record[1]=my.y;
	record[2]=my.z;

	record[3]=you.x;   // Direction from which we are pushing the energy sphere is the spaceship that is firing
	record[4]=you.y;   // you is the creating entity (ie the ship that is firing)
	record[5]=my.z+start_z;
	record[6]=ballmass; // mass
	record[7]=power*ballspeed; // speed
	NewtonBodyAddImpulse(body,record);
	
	
	while (spin_timer < 1) && (my.ENTITY_TYPE != KILLED) 
	
	{spin_timer = spin_timer + (time_step/16);wait (1); }

	recent_weapon_fire = off;  // and then allow another energe sphere to be launched
	
	while (spin_timer < 4) && (my.ENTITY_TYPE != KILLED)  
	{spin_timer = spin_timer + (time_step/16);wait (1);}  // sleep a total of 64 seconds or until removed
	
	NewtonRemoveEntity(my);  // release this energy sphere from the physics engine
	ent_remove(my);          // and get rid of this energy sphere
	num_energy_spheres -= 1;
}



function display_time ()
{

	while (!time_display_running) && (!no_timer) {wait (1);}
	while (1) 
	{
		if (time_display_running) && (!no_timer) {
			elapsed_time -= time_frame / 16;
			if (elapsed_time < 0) 
			{
				elapsed_time = 0;
				time_display_running = 0;
			}
			if (elapsed_time > 0) {
				adjusted_elapsed_time = 20+elapsed_time;
				} else {
				adjusted_elapsed_time = 0;
			}
		} 
		wait(1);
	}	
}

function right_ship(ship_ptr) {
	while (int(ship.tilt) != 0) {
		if (int(ship.tilt) > 0) {ship.tilt -= 1;}
		if (int(ship.tilt) < 0) {ship.tilt += 1;}
		sleep (1);
	}
	while (int(ship.roll) != 0) {
		if (int(ship.roll) > 0) {ship.roll -= 1;}
		if (int(ship.roll) < 0) {ship.roll += 1;}
		sleep (1);
	}
	ship_righted = 1;
}



////////////////////////////////////////////////////////////////////////////////////////////
// Display the thruster flames.
//
// This process runs on the server, and on all clients via a proc_local
// the my pointer should = the player and ship pointer on all clients.
// the my pointer should = each individual ship on the server
//
/////////////////////////////////////////////////////////////////////////////////////////////

function show_thruster (&src, &loc)
{
	if (!connection) && (!ship_landed) {                   // Display the time if we are NOT in multiplayer mode 
		if (!time_display_running)
		{time_display_running = 1;}
	}	
	
	vec_diff(temp,loc,src); // point the flame the way the thruster is pointed
	vec_normalize (temp,2.5); // cut it back to a small length flame
	effect_local (particle_jet,1, loc, temp);  // use effect local to keep the network traffic low

}

entity* weapon_ptr;

/////////////////////////////////////////////////////////////////////////////////////
//
// desc: thruster function is started on both the client and the server
//       On the server side we want it to handle the physics of every entity 
//       as well as show the thrusters
//
//       but on the client side all we want it to do is show the thrusters
//       
//
/////////////////////////////////////////////////////////////////////////////////////

// push towards location (usually center of the ship) from source (thruster)

function thruster (&loc,&src,power)
{
	var body;

	if (connection != 2) && (!mp_no_physics) // This is either a 'non MP' game or we are the server, so do the physics here
	{
		// copy impact point on target
		newtonImpulseRecord[0] = loc [0]; // x
		newtonImpulseRecord[1] = loc [1]; // y
		newtonImpulseRecord[2] = loc [2]; // z
		
		// copy origin of bullet (use to determone the direction of the impulse)
		newtonImpulseRecord[3] = src [0]; // x
		newtonImpulseRecord[4] = src [1]; // y
		newtonImpulseRecord[5] = src [2]; // z	
		
		// copy the bullet mass
		newtonImpulseRecord[6] = (power/4)*thruster_factor;
		
		// copy the bullet speed
		newtonImpulseRecord[7] = (power/2)*thruster_factor;
		
		body = NewtonGetBody (me);	
		NewtonBodyAddImpulse (body, newtonImpulseRecord);
		
	}
	
	show_thruster (loc, src);  // but always show the thrusters

}



var temp1 [3];
var temp2 [3];



function thruster_forward (thrust_power)
{
	// REAR right pod top
	vec_for_vertex (temp1,me,394);  // push from Front Top Thruster
	vec_for_vertex (temp2,me,385);  // towards the REAR Top thruster location 
	thruster (temp1,temp2,thrust_power);

	
	// REAR right pod bottom
	vec_for_vertex (temp1,me,391);  // push from Front bottom Thruster
	vec_for_vertex (temp2,me,386);  // towards the REAR bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
	// REAR left pod top
	vec_for_vertex (temp1,me,561);  // push from Front Top Thruster
	vec_for_vertex (temp2,me,552);  // towards the REAR Top thruster location 
	thruster (temp1,temp2,thrust_power);


	// REAR left pod bottom
	vec_for_vertex (temp1,me,558);  // push from Front bottom Thruster
	vec_for_vertex (temp2,me,553);  // towards the REAR bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
}


function thruster_aft (thrust_power)
{
	// Front right pod top
	vec_for_vertex (temp1,me,385);  // push from REAR Top Thruster
	vec_for_vertex (temp2,me,394);  // towards the FRONT Top thruster location 
	thruster (temp1,temp2,thrust_power);

	
	// Front right pod bottom
	vec_for_vertex (temp1,me,386);  // push from REAR bottom Thruster
	vec_for_vertex (temp2,me,391);  // towards the FRONT bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
	// REAR left pod top
	vec_for_vertex (temp1,me,552);  // push from REAR Top Thruster
	vec_for_vertex (temp2,me,561);  // towards the FRONT Top thruster location 
	thruster (temp1,temp2,thrust_power);


	// REAR left pod bottom
	vec_for_vertex (temp1,me,553);  // push from REAR bottom Thruster
	vec_for_vertex (temp2,me,558);  // towards the FRONT bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
}

function thruster_port (thrust_power)
{
	//  left pod Side Front top
	vec_for_vertex (temp1,me,476);     // From Left Side Pod
	vec_for_vertex (temp2,me,316);     // Toward Right Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  left pod Side Front bottom
	vec_for_vertex (temp1,me,473);     // From Left Side Pod
	vec_for_vertex (temp2,me,314);     // Toward Right Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  left pod Side Rear top
	vec_for_vertex (temp1,me,470);     // From Left Side Pod
	vec_for_vertex (temp2,me,302);     // Toward Right Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  left pod Side Rear Bottom
	vec_for_vertex (temp1,me,472);     // From Left Side Pod
	vec_for_vertex (temp2,me,311);     // Toward Right Side Pod
	thruster (temp1,temp2,thrust_power);
	
}

function thruster_Starboard  (thrust_power)
{
	// Right pod Side Front top
	vec_for_vertex (temp1,me,316);     // From Right Side Pod
	vec_for_vertex (temp2,me,476);     // Toward Left Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  Right pod Side Front bottom
	vec_for_vertex (temp1,me,314);     // From Right Side Pod
	vec_for_vertex (temp2,me,473);     // Toward Left Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  Right pod Side Rear top
	vec_for_vertex (temp1,me,302);     // From Right Side Pod
	vec_for_vertex (temp2,me,470);     // Toward Left Side Pod
	thruster (temp1,temp2,thrust_power);
	
	//  Right pod Side Rear Bottom
	vec_for_vertex (temp1,me,311);     // From Right Side Pod
	vec_for_vertex (temp2,me,472);     // Toward Left Side Pod
	thruster (temp1,temp2,thrust_power);
	
	

}


function thruster_lift (thrust_power)
{
	// Fire Left pod Bottom Forward
	vec_for_vertex (temp1,me,557);     // Toward left Bottom
	vec_for_vertex (temp2,me,464);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Bottom Aft
	vec_for_vertex (temp1,me,555);     // Toward left Bottom
	vec_for_vertex (temp2,me,549);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Bottom Forward
	vec_for_vertex (temp1,me,390);     // Toward Right Bottom
	vec_for_vertex (temp2,me,297);     // From Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Bottom Aft
	vec_for_vertex (temp1,me,388);     // Toward Right Bottom
	vec_for_vertex (temp2,me,382);     // From Right Top
	thruster (temp1,temp2,thrust_power);
}

function thruster_decent (thrust_power)
{
	// Fire Left pod Top Forward
	vec_for_vertex (temp1,me,464);     // Toward left Bottom
	vec_for_vertex (temp2,me,557);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Top Aft
	vec_for_vertex (temp1,me,549);     // From left Bottom
	vec_for_vertex (temp2,me,555);     // Toward Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Top Forward
	vec_for_vertex (temp1,me,297);     // From Right Bottom
	vec_for_vertex (temp2,me,390);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Top Aft
	vec_for_vertex (temp1,me,382);     // From Right Bottom
	vec_for_vertex (temp2,me,388);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);
}


function pan_port (thrust_power)
{
	// right pod top
	vec_for_vertex (temp1,me,394);  // push from Front Top Thruster
	vec_for_vertex (temp2,me,385);  // towards the REAR Top thruster location 
	thruster (temp1,temp2,thrust_power);

	
	// right pod bottom
	vec_for_vertex (temp1,me,391);  // push from Front bottom Thruster
	vec_for_vertex (temp2,me,386);  // towards the REAR bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
	
	//  left pod top
	vec_for_vertex (temp1,me,552);  // push from REAR Top Thruster
	vec_for_vertex (temp2,me,561);  // towards the FRONT Top thruster location 
	thruster (temp1,temp2,thrust_power);


	// left pod bottom
	vec_for_vertex (temp1,me,553);  // push from REAR bottom Thruster
	vec_for_vertex (temp2,me,558);  // towards the FRONT bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
}

function pan_starboard (thrust_power)
{
	
	// Fire Rear left pod top
	vec_for_vertex (temp1,me,561);  // push from Front Top Thruster
	vec_for_vertex (temp2,me,552);  // towards the REAR Top thruster location 
	thruster (temp1,temp2,thrust_power);


	// Fire Rear left pod bottom
	vec_for_vertex (temp1,me,558);  // push from Front bottom Thruster
	vec_for_vertex (temp2,me,553);  // towards the REAR bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	// Fire Front right pod top
	vec_for_vertex (temp1,me,385);  // push from REAR Top Thruster
	vec_for_vertex (temp2,me,394);  // towards the FRONT Top thruster location 
	thruster (temp1,temp2,thrust_power);

	
	// Fire Front right pod bottom
	vec_for_vertex (temp1,me,386);  // push from REAR bottom Thruster
	vec_for_vertex (temp2,me,391);  // towards the FRONT bottom thruster location 
	thruster (temp1,temp2,thrust_power);
	
	
}

function tilt_up (thrust_power)
{
	// Fire Left pod Bottom Forward
	vec_for_vertex (temp1,me,557);     // Toward left Bottom
	vec_for_vertex (temp2,me,464);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	
	// Fire Right pod Bottom Forward
	vec_for_vertex (temp1,me,390);     // Toward Right Bottom
	vec_for_vertex (temp2,me,297);     // From Right Top
	thruster (temp1,temp2,thrust_power);
	
	
	// Fire Left pod Top Aft
	vec_for_vertex (temp1,me,549);     // From left Bottom
	vec_for_vertex (temp2,me,555);     // Toward Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Top Aft
	vec_for_vertex (temp1,me,382);     // From Right Bottom
	vec_for_vertex (temp2,me,388);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);	
}

function tilt_down (thrust_power)
{
	// Fire Left pod Top Forward
	vec_for_vertex (temp1,me,464);     // Toward left Bottom
	vec_for_vertex (temp2,me,557);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Bottom Aft
	vec_for_vertex (temp1,me,555);     // Toward left Bottom
	vec_for_vertex (temp2,me,549);     // From Left Top
	thruster (temp1,temp2,thrust_power);

	// Fire Right pod Top Forward
	vec_for_vertex (temp1,me,297);     // From Right Bottom
	vec_for_vertex (temp2,me,390);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Bottom Aft
	vec_for_vertex (temp1,me,388);     // Toward Right Bottom
	vec_for_vertex (temp2,me,382);     // From Right Top
	thruster (temp1,temp2,thrust_power);	

}

// for the roll we will need 'move' the target position on the ship (temp1.y)
function roll_port (thrust_power)
{
	// Fire Left pod Top Forward
	vec_for_vertex (temp1,me,464);     // Toward left Bottom
	vec_for_vertex (temp2,me,557);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Top Aft
	vec_for_vertex (temp1,me,549);     // From left Bottom
	vec_for_vertex (temp2,me,555);     // Toward Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Bottom Forward
	vec_for_vertex (temp1,me,390);     // Toward Right Bottom
	vec_for_vertex (temp2,me,297);     // From Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Bottom Aft
	vec_for_vertex (temp1,me,388);     // Toward Right Bottom
	vec_for_vertex (temp2,me,382);     // From Right Top
	thruster (temp1,temp2,thrust_power);
	
}

function roll_starboard (thrust_power)
{
	
	// Fire Right pod Top Forward
	vec_for_vertex (temp1,me,297);     // From Right Bottom
	vec_for_vertex (temp2,me,390);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Right pod Top Aft
	vec_for_vertex (temp1,me,382);     // From Right Bottom
	vec_for_vertex (temp2,me,388);     // Toward Right Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Bottom Forward
	vec_for_vertex (temp1,me,557);     // Toward left Bottom
	vec_for_vertex (temp2,me,464);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
	// Fire Left pod Bottom Aft
	vec_for_vertex (temp1,me,555);     // Toward left Bottom
	vec_for_vertex (temp2,me,549);     // From Left Top
	thruster (temp1,temp2,thrust_power);
	
}



function fire_weapon()
{

	if (connection != 2)   // don't actually fire weapons if we are a client only
	{
		if (my.SPHERE_ENERGIZED) // max of 1 simultaneous energy balls
		{
			my.SPHERE_ENERGIZED = off;  // prevent another fire until 'energy sphere generator' is recharged
			energize_sphere();			temp1.x = my.x + start_x + (100 * cos(my.pan));    // start.x was 35
			temp1.y = my.y + start_y + (100 * sin(my.pan));    // start.y was 35
			temp1.z = my.z  + start_z + (100 * sin(my.tilt));  // start.z was 35
			
			weapon_ptr = ent_create ("kugel1.mdl",temp1,energy_sphere);
		}
	}
}


sound jetEngineSound = <jetengine.wav>;
var JEShandle;
var JESplaying;

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Gather any inputs entered at the keyboard by our player, and store them in a single word (skill 1) of
// the players entity. If we are the client, we will need to send it to the server for appropriate action.
// If we are the server, there is no need to send anything, but at some point I will probably change the
// code to 'slow' the server response down to equal the average delay of all the clients.
/////////////////////////////////////////////////////////////////////////////////////////////////////////
var astrength[3] = 1,2,2;	// use this to se the multiplyer for pan, tilt, roll strength

function gather_inputs()
{

	var prev_KeyFlags;  // previous loops Keyflag settings
	var prev_aforce_pan;
	var prev_aforce_tilt;
	var prev_aforce_roll;
	
	
	//	sleep (10); // wait awhile before allowing any movement NOTE: Change to a 'ready flag' of some kind
	

	while (1)
	{
		player.KeyFlags = 0;  // reset our flags that indicate what key or keys are being pressed
		ifdef joystick;
			// uses astrength as a multiplier to control the force of the thrusters
			// uses the int value to avoid small adjustmetns
			
			player.aforce_pan = int(astrength.PAN*-(joy_rot.x/255)*2); 
			player.aforce_tilt = int(astrength.TILT*(JOY_FORCE.Y));
			player.aforce_roll = int(-astrength.ROLL*(JOY_FORCE.X));
			// the following code is used to for flat plane movement (ie, forward back left right)
			if ( joy_hat == 0) {player.Keyflags |= BIT0;}
			if ( joy_hat == 45) {player.Keyflags |= BIT0;player.Keyflags |= BIT3;}
			if ( joy_hat == 90) {player.Keyflags |= BIT3;}
			if ( joy_hat == 135) {player.Keyflags |= BIT1;player.Keyflags |= BIT3;}
			if ( joy_hat == 180) {player.Keyflags |= BIT1;}
			if ( joy_hat == 225) {player.Keyflags |= BIT1;player.Keyflags |= BIT2;}
			if ( joy_hat == 270) {player.Keyflags |= BIT2;}
			if ( joy_hat == 315) {player.Keyflags |= BIT0;player.Keyflags |= BIT2;}
			
			if ( joy_1 )  {player.KeyFlags |= BIT12;} 

			if ( joy_5 )  {player.KeyFlags |= BIT11;} 
			if ( joy_6 )  {player.KeyFlags |= BIT10;} 
		endif;
		
		// Then determine the keys we care about that are being pressed and set the corresponding bits in KeyFlags
		
		if (key_w) {player.KeyFlags |= BIT0;}   
		if (key_s) {player.KeyFlags |= BIT1;}  
		if (key_a) {player.KeyFlags |= BIT2;}  
		if (key_d) {player.KeyFlags |= BIT3;} 
		if (key_j) {player.KeyFlags |= BIT4;} 
		if (key_l) {player.KeyFlags |= BIT5;} 
		if (key_k) {player.KeyFlags |= BIT6;}  
		if (key_i) {player.KeyFlags |= BIT7;} 
		if (key_u) {player.KeyFlags |= BIT8;} 
		if (Key_o) {player.KeyFlags |= BIT9;} 		
		if (key_q) {player.KeyFlags |= BIT10;}	
		if (key_e) {player.KeyFlags |= BIT11;}  
		//		if (key_space) {player.KeyFlags |= BIT12;}  
		
		// if the server says not to do any physics, then zero out all the key / joystick activity
		
		if (mp_no_physics) {
			player.KeyFlags = 0;
			player.aforce_pan = 0;
			player.aforce_tilt = 0;
			player.aforce_roll = 0;
			
		}
		// if the ship has not landed, and we are NOT playing the jet engine sound, and 
		// any controls are active, then play it	
		
		if (!ship_landed == 1) {
			if (( !JESplaying) && ((player.KeyFlags)  || (player.aforce_pan) || (player.aforce_tilt) || (player.aforce_roll)))
			{
				JESplaying = on; jEShandle =	snd_loop (jetEngineSound,30,0);
			}
			// if we are playing the jet sound and no key is pressed, then stop it
			if ((JESplaying) && (!player.KeyFlags)  && (!player.aforce_pan) && (!player.aforce_tilt) && (!player.aforce_roll))
			{snd_stop (JEShandle); JESplaying = off;}
		} 
		else {
			if ((JESplaying) &&
			((!player.KeyFlags)  && (!player.aforce_pan) && (!player.aforce_tilt) && (!player.aforce_roll)) )
			{snd_stop (JEShandle); JESplaying = off;}
		}

		
		
		// only send the KeyFlags if they have changed. 
		if (player.KeyFlags != prev_KeyFlags)
		{
			send_skill(player.KeyFlags,SEND_ALL); // send the key settings in reliable mode to all clients
		}
		if (player.aforce_pan != prev_aforce_pan) || (player.aforce_tilt != prev_aforce_tilt)|| (player.aforce_roll != prev_aforce_roll)
		{
			send_skill (player.aforce,SEND_ALL+SEND_VEC);
		}
		prev_KeyFlags = player.KeyFlags;
		prev_aforce_pan = player.aforce_pan;
		prev_aforce_tilt = player.aforce_tilt;
		prev_aforce_roll = player.aforce_roll;

		wait(1);
	}  // end while
} // end gather_inputs()

/**************************************************************************
Function to display messages on the client side only
called by proc_client for each ship.
***************************************************************************/

function message_control()
{
	while (1)
	{
		if (my.ENTITY_STATUS==OUT_OF_BOUNDS){
			txt_out.visible=on;
			} else {
			txt_out.visible=off;
		}
		
		// if we are not in practice mode, then issue pass fail messages
		if (my.ENTITY_STATUS==PASS) && (!no_timer){
			txt_pass.visible=on;
			}else {
			txt_pass.visible=off;
		}

		if (my.ENTITY_STATUS==FAIL) && (!no_timer){
			txt_fail.visible=on;
			}else {
			txt_fail.visible=off;
		}
		
		if (my.ENTITY_STATUS==WINNER) {   // We must have hit a ore hauler at the wrong phase of the game
			txt_win.visible=on;
			} else {
			txt_win.visible=off;
		}
		
		if (my.ENTITY_STATUS==LOSER) {   // We must have hit a ore hauler at the wrong phase of the game
			txt_lose.visible=on;
			} else {
			txt_lose.visible=off;
		}

		if (my.ENTITY_STATUS==PAD_OWNER) {
			txt_lock.visible=on;
			} else {
			txt_lock.visible=off;
		}
		
		if (my.ENTITY_STATUS==PAD_OWNER_MP) {
			txt_hold.visible=on;
			} else {
			txt_hold.visible=off;
		}
		wait(1);	
	}
	wait(1);
}

function scroll_message_1 ()
{
	var sleep_count;
	mp_no_physics = 1;          // force them to see the first message by preventing any ship controls
	
	// display and scroll in first 3 lines

	msg_txt.POS_X = screen_size.x/2;
	msg_txt.POS_Y = screen_size.y + (3 * msg_txt.char_y);
	msg_txt.CENTER_X = ON;
	msg_txt.TRANSPARENT = OFF;
	msg_txt.VISIBLE = ON;

	while(msg_txt.POS_Y > (screen_size.y/8))
	{
		msg_txt.POS_Y -= 10 * TIME;
		wait(1);
	}
	
}


function scroll_message_2 ()
{
	var sleep_count;
	if (!time_display_running) {
		// diplay and scroll in Conitec line while scrolling out other lines
		msg_txt2.POS_X = screen_size.x/2;
		msg_txt2.POS_Y = screen_size.y + (3 * msg_txt.char_y);
		msg_txt2.CENTER_X = ON;
		msg_txt2.TRANSPARENT = OFF;
		msg_txt2.VISIBLE = ON;

		while(msg_txt2.POS_Y > (screen_size.y/11))
		{
			msg_txt.POS_Y -= 10 * TIME;
			msg_txt2.POS_Y -= 10 * TIME;
			wait(1);
		}
	}
	
	msg_txt.VISIBLE = OFF;

	// done
}  

function interruptable_sleep (sleep_time)
{
	var sleep_count;
	sleeping = 1;
	while (sleep_count < sleep_time) && (!time_display_running)
	{
		sleep (1);
		sleep_count +=1;
	}
	sleeping = 0;
}

function message_gamestart()
{
	mp_no_physics = 1;  // prevent user from taking control of ship

	ifndef practice;	
		msg_txt.STRING = msg_str1;
		msg_txt2.STRING = msg_str2;
	endif;
	ifdef practice;
		msg_txt.STRING = msg_str10;
		msg_txt2.STRING = msg_str11;
	endif;


	scroll_message_1();	

	
	var sleep_count=0;	
	
	interruptable_sleep (20);
	while (sleeping) {wait (1);}  // spin while we wait for the sleep to happen

	mp_no_physics = 0;  // allow user to take control early
	
	scroll_message_2();
	
	
	interruptable_sleep (15);
	while (sleeping) {wait (1);}  // spin while we wait for the sleep to happen

	msg_txt2.visible = off;	
	
	ifndef nohelp;
		help_panel.visible=on;
	endif;
	
	ifndef practice;
		timer_panel.visible=on;
		distance_panel.visible=on;
	endif;
	
	ifdef practice;
		no_timer = 1;
	endif;	
	
}


function message_end_landing_test ()
{
	message_running = 1;
	msg_txt.STRING = msg_str7;
	msg_txt2.STRING = msg_str8;
	scroll_message_1();
	sleep (15);
	scroll_message_2();
	sleep (15);
	msg_txt2.visible = off;			
	message_running = 0;
}

function message_success_ending()
{
	message_running = 1;
	msg_txt.STRING = msg_str3;
	msg_txt2.STRING = msg_str4;
	scroll_message_1();
	sleep (15);
	scroll_message_2();
	sleep (15);
	msg_txt2.visible = off;			
	message_running = 0;
}

function message_failed_ending()
{
	message_running = 1;
	msg_txt.STRING = msg_str5;
	msg_txt2.STRING = msg_str6;
	scroll_message_1();
	sleep (15);
	scroll_message_2();
	sleep (15);
	msg_txt2.visible = off;	
	message_running = 0;			
}

function message_credits ()
{
	message_running = 1;
	msg_txt.STRING = msg_str20;
	msg_txt2.STRING = msg_str21;
	scroll_message_1();
	sleep (15);
	scroll_message_2();
	sleep (15);
	msg_txt2.visible = off;	
	message_running = 0;			
}
/***************************************************************
Function to end the game and start the credit display
***************************************************************/
function exit_game ()
{
	if (game_is_exiting) {return;} // don't run twice
	
	sleep (3); // sleep a couple of seconds to allow the user to watch 
	
	game_is_exiting = 1;
	
	time_display_running = 0;       // just in case it's running, stop it

	help_panel.visible=off;         // turn off any panels for credits msg
	timer_panel.visible=off;
	distance_panel.visible=off;

	
	NewtonRemoveEntity(player);     // release this ship from the physics engine
	player.ENTITY_STATUS=ACTIVE;	  // shut off any win / lose messages
	
	place_ship();                   // move the ship out to where the messages are readable
	
	if (move_hauler_failed > 1) {
		message_failed_ending ();  // roll message to let them know they need to restart
		} else {
		message_success_ending ();// roll sucess message
	}
	
	//	ON_SPACE = escape_credits;
	//	ON_ESC = escape_credits;
	
	while(message_running)  {wait(1);}
	
	//	game_save("hscore",0,SV_INFO);  // save everything we need to retain
	sleep (5);
	
	message_credits();  // roll the ending credits
	while(message_running)  {wait(1);}
	exit;
	
}


on_mouse_right = free_look_toggle;